#ifndef BBOX_H_
#define BBOX_H_

#include <vector>
#include "vector.h"
#include "ray.h"
#include "intinfo.h"

class Object;

class BBox {
public:
	Vector3 min, max;

	BBox();
	BBox(const Vector3 &min, const Vector3 &max);
	
	bool intersection(const Ray &ray) const;
};

class BBoxNode {
private:
	BBox bbox;
	std::vector<BBoxNode*> children;
	std::vector<Object*> objects;
public:
	BBoxNode(const BBox &bbox);
	~BBoxNode();
	
	bool intersection(const Ray &ray, IntInfo* inf) const;
	void add_child(BBoxNode* node);
	void add_object(Object* obj);
};

#endif
