#ifndef OBJECT_H_
#define OBJECT_H_

#include "color.h"
#include "intinfo.h"
#include "ray.h"
#include "bbox.h"

struct Material {
	Color kd;
	Color ks;
	double specexp;
	double kr;
};
		
class Object {
protected:
	Material material;
	BBox bbox;

public:
	Object();
	virtual bool intersection(const Ray &ray, IntInfo* i_info) const = 0;

	Material* get_material();
	const Material* get_material() const;

	virtual void calc_bbox() = 0;
};

#endif
