#ifndef SPHEREFLAKE_H_
#define SPHEREFLAKE_H_

#include <vector>
#include "object.h"
#include "sphere.h"

class SphereFlake : public Object {
private:
	Sphere *sph;
	SphereFlake *subflakes[6];

	Vector3 center;
	double radius;

public:
	SphereFlake(const Vector3 &center, double radius);
	~SphereFlake();

	bool intersection(const Ray &ray, IntInfo* i_info) const;

	void calc_bbox();

	friend SphereFlake *create_sflake(const Vector3 &center, double radius, int iter);
};

SphereFlake *create_sflake(const Vector3 &center, double radius, int iter);

#endif
